#include <xstep.h>
#include <stdio.h>
#include <stdlib.h>

void w2keypress(XSWidget *wid) {

	printf("key pressed (%lu)\n",
		XLookupKeysym(&wid->event->xkey,0));
}

void w2buttonpress(XSWidget *wid) {

	printf("mouse button pressed (%d,%d)\n",
		wid->event->xbutton.x,
		wid->event->xbutton.y);
}

void w2pointermotion(XSWidget *wid) {

	printf("pointer motion (%d,%d)\n",
		wid->event->xbutton.x,
		wid->event->xbutton.y);
}

void w2expose(XSWidget *wid) {

	printf("exposed area %dx%d in position %d,%d\n",
		wid->event->xexpose.width,
		wid->event->xexpose.height,
		wid->event->xexpose.x,
		wid->event->xexpose.y);
}

int main(int argc,char **argv) {

	XSWidget 	*d1,*w1,*w2;
	
	d1=XSDesktop(getenv("DISPLAY"),argv,argc);
	w1=XSWindow(d1,0,0,400,400,"event example");
	
	w2=XSWindow(w1,8,8,200,200,"sub-window");	

	w2->on.event[KeyPress]		=w2keypress;
	w2->on.event[ButtonPress]	=w2buttonpress;
	w2->on.event[MotionNotify]	=w2pointermotion;
	w2->on.event[Expose]		=w2expose;
	
	w2->bgcolor=w2->white;

	   XSButton(w1,-8,-8,72,24,"Close",XSWindowClose);
	
	while(XSCheckEvent(d1,XS_BLOCK));

	return 0;
}
