#include <xstep.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

XSImage  *image;
XSPixmap *pixmap;

XSImage *readimage(char *name) {

	XSImage *aux=NULL;
	FILE 	*fp;
	char 	tmp[80],format[80],*data;
	int 	width,height,max;
	
	fp=fopen(name,"r");
	
	if(fp) {

		fgets(format,80,fp);

		fprintf(stderr,"checking for PGM/P5 format...\n");

		if(!strncmp(format,"P5",2)) {
		
			while(fgets(tmp,80,fp)) if(tmp[0]!='#') break;
			sscanf(tmp,"%d %d",&width,&height);
			while(fgets(tmp,80,fp)) if(tmp[0]!='#') break;
			sscanf(tmp,"%d",&max);
			data=(char *)malloc(width*height);
			fread(data,1,width*height,fp);
			fclose(fp);
		
			if((aux=XSImageCreate(width,height,data,XS_IMAGE_GRAY))) aux->name=name;
		}

		fprintf(stderr,"checking for PPM/P6 format...\n");
				
		if(!strncmp(format,"P6",2)) {
		
			while(fgets(tmp,80,fp)) if(tmp[0]!='#') break;
			sscanf(tmp,"%d %d",&width,&height);
			while(fgets(tmp,80,fp)) if(tmp[0]!='#') break;
			sscanf(tmp,"%d",&max);
			data=(char *)malloc(width*height*3);
			fread(data,1,width*height*3,fp);
			fclose(fp);
		
			if((aux=XSImageCreate(width,height,data,XS_IMAGE_RGB24))) aux->name=name;
		}
	}
	return aux;
}

void w1oncreate(XSWidget *wid) {
	
	XSWidgetCreate(wid);
	
	pixmap=XSPixmapCreate(wid,image->width,image->height,NULL,XS_PIXMAP_XSHM);

	XSImage2Pixmap(wid,image,pixmap,True);

	XSetWindowBackgroundPixmap(wid->display,wid->window,pixmap->pixmap);
	XClearWindow(wid->display,wid->window);

	wid->on.create=NULL;
}

int main(int argc,char **argv) {

	XSWidget *d1,*w1;

	if(!(image=readimage(argv[1]))) {
	
		fprintf(stderr,"failed to open [%s], exiting\n\n",
			argv[1]);
				
		return -1;
	}
	
	fprintf(stderr,
		"sucess: %dx%d pixels read from %s (%s)\n",
		image->width,
		image->height,
		image->name,
		image->format==XS_IMAGE_RGB24?"RGB24":"GRAY");
		
	d1=XSDesktop(getenv("DISPLAY"),argv,argc);
	w1=XSWindow(d1,0,0,image->width,image->height,image->name);

	w1->on.event[KeyPress]=XSWindowClose;
	w1->on.create=w1oncreate;
	
	while(XSCheckEvent(d1,XS_BLOCK));

	return 0;
}
